import QtQuick 2.4

Preset {
    presetArrays: [
        // preset 0: all in
        {
            "num": [ 500, sync ],
            "meshIndex": [ 0, sync ],
            "texInd0": [ 0, sync ],
            "texInd1": [ 0, sync ],
            "blendMode": [ 1, sync ],
            "depthEnabled": [ 1, sync ],
            "scale": [ 0.1, sync ], "scaleZ": [ 1.0, sync ],
            "x": [ 0.0, sync ], "y": [ 0.0, sync ], "z": [0.0, sync],
            "bright": [ 4.0, sync ], "ambient": [ 0.1, sync ],
            "uvScale": [ 0.25, sync ], "uvScaleMin": [ 0.0, sync ], "uvScaleMax": [ 10.0, sync ],
            "uvRandom": [ 0.0, sync ], "uvOfsXRand": [ 0.0, sync ], "uvOfsYRand": [ 0.0, sync ],
            "prevBlur": [ 0.8, sync ], "prevBlurType": [ 0, sync ],
            "bump": [ 0.0, sync ], "genUV": [ 1.0, sync ], "alpha": [ 1.0, sync ],
            "emitThr": [ 0.0, sync ], "emitAmp": [ 1.0, sync ],
            "cenX": [ 2.0, sync ], "cenY": [ 0.4, sync ], "cenZ": [ -1.0, sync ],
            "rotX": [ 0.0, sync ], "rotY": [ 231.0, sync ], "rotZ": [ 0.0, sync ],
            "globalRotX": [ 0.0, sync ], "globalRotY": [ 0.0, sync ], "globalRotZ": [ 0.0, sync ],
            "globalScale": [ 1.0, sync ],
            "rotXDel": [ -1.6, syncFFT ], "rotYDel": [ 0.0, sync ], "rotZDel": [ 0.223, sync ],
            "rotSingleX": [ 22.0, syncFFT ], "rotSingleY": [ 22.0, sync ], "rotSingleZ": [ 0.0, sync ],
            "radAmp": [ 0.0, sync ], "radAmpIn": [ 0.2, sync ], "radFreq": [ 0.3, sync ], "radFreqIn": [ 0.1, sync ],
            "radOfs": [ 0.2, sync ], "radRotDel": [ 0.15, sync ], "radDel": [ 0.01, sync ],
            "delOfs": [ 0.0, sync ],
            "spx": [ 0.0, sync ], "spy": [ 0.0, sync ], "spz": [ 0.0, sync ],
            "emitPercent": [ 0.0, sync ],
            "emitAngSpd": [ 0.0, sync ],
            "emitVel.x": [ 0.0, sync ], "emitVel.y": [ 0.0, sync ], "emitVel.z": [ 0.0, sync ],
            "emitColThr": [ 0.0, sync ], "emitGrayness": [ 0.0, sync ],
            "mirrorX": [ 0.0, sync ], "mirrorXPos": [ 0.0, sync ], "mirrorXClip": [ 0.0, sync ],
            "mirrorY": [ 0.0, sync ], "mirrorYPos": [ 0.0, sync ], "mirrorYClip": [ 0.0, sync ],
            "mirrorZ": [ 0.0, sync ], "mirrorZPos": [ 0.0, sync ], "mirrorZClip": [ 0.0, sync ],
            "circCenX": [ 0.0, sync ], "circCenY": [ 0.0, sync ], "circCenZ": [ 0.0, sync ],
            "circDistX": [ 0.0, sync ], "circDistY": [ 0.0, sync ], "circDistZ": [ 0.0, sync ],
            "circRotX": [ 0.0, sync ], "circRotY": [ 0.0, sync ], "circRotZ": [ 0.0, sync ],
        },
        // preset 1: karvalakki
        {
            "num": [ 500, sync ],
            "meshIndex": [ 0, sync ],
            "texInd0": [ 0, sync ],
            "texInd1": [ 0 ],
            "blendMode": [ 1 ],
            "depthEnabled": [ 1 ],
            "scale": [ 0.1, sync ], "scaleZ": [ 1.0 ],
            "x": [ 0.0, sync ], "y": [ 0.0, sync ], "z": [0.0, sync],
            "bright": [ 4.0, sync ], "ambient": [ 0.1, sync ],
            "uvScale": [ 0.25 ], "uvScaleMin": [ 0.0 ], "uvScaleMax": [ 10.0 ],
            "uvRandom": [ 0.0 ], "uvOfsXRand": [ 0.0 ], "uvOfsYRand": [ 0.0 ],
            "prevBlur": [ 0.8 ], "prevBlurType": [ 0 ],
            "bump": [ 0.0 ], "genUV": [ 1.0 ], "alpha": [ 1.0 ],
            "emitThr": [ 0.0 ], "emitAmp": [ 1.0 ],
            "cenX": [ 2.0, sync ], "cenY": [ 0.4, sync ], "cenZ": [ -1.0 ],
            "rotX": [ 0.0 ], "rotY": [ 231.0 ], "rotZ": [ 0.0, sync ],
            "globalRotX": [ 0.0, sync ], "globalRotY": [ 0.0, sync ], "globalRotZ": [ 0.0, sync ],
            "globalScale": [ 1.0, sync ],
            "rotXDel": [ -1.6, syncFFT ], "rotYDel": [ 0.0, sync ], "rotZDel": [ 0.223 ],
            "rotSingleX": [ 22.0, syncFFT ], "rotSingleY": [ 22.0 ], "rotSingleZ": [ 0.0 ],
            "radAmp": [ 0.0 ], "radAmpIn": [ 0.2 ], "radFreq": [ 0.3 ], "radFreqIn": [ 0.1 ],
            "radOfs": [ 0.2 ], "radRotDel": [ 0.15 ], "radDel": [ 0.01 ],
            "delOfs": [ 0.0 ],
            "spx": [ 0.0 ], "spy": [ 0.0 ], "spz": [ 0.0 ],
            "emitPercent": [ 0.0, sync ],
            "emitAngSpd": [ 0.0, sync ],
            "emitVel.x": [ 0.0 ], "emitVel.y": [ 0.0 ], "emitVel.z": [ 0.0 ],
            "emitColThr": [ 0.0 ], "emitGrayness": [ 0.0 ],
            "mirrorX": [ 0.0, sync ], "mirrorXPos": [ 0.0, sync ], "mirrorXClip": [ 0.0, sync ],
            "mirrorY": [ 0.0, sync ], "mirrorYPos": [ 0.0, sync ], "mirrorYClip": [ 0.0, sync ],
            "mirrorZ": [ 0.0, sync ], "mirrorZPos": [ 0.0, sync ], "mirrorZClip": [ 0.0, sync ],
            "circCenX": [ 0.0, sync ], "circCenY": [ 0.0, sync ], "circCenZ": [ 0.0, sync ],
            "circDistX": [ 0.0, sync ], "circDistY": [ 0.0, sync ], "circDistZ": [ 0.0, sync ],
            "circRotX": [ 0.0, sync ], "circRotY": [ 0.0, sync ], "circRotZ": [ 0.0, sync ],

        },

        // preset 2: punatulikukka
        {
            "num": [ 40 ],
            "meshIndex": [ 0, sync ],
            "texInd0": [ 0, sync ],
            "texInd1": [ 0 ],
            "blendMode": [ 1 ],
            "depthEnabled": [ 1 ],
            "scale": [ 0.1, sync ], "scaleZ": [ 1.0 ],
            "x": [ 0.0, sync ], "y": [ 0.0 ], "z": [ -1.0 ],
            "bright": [ 2.6 ], "ambient": [ 0.01 ],
            "uvScale": [ 0.1 ], "uvScaleMin": [ 0.0 ], "uvScaleMax": [ 10.0 ],
            "uvRandom": [ 0.0 ], "uvOfsXRand": [ 0.0 ], "uvOfsYRand": [ 0.0 ],
            "prevBlur": [ 0.41 ], "prevBlurType": [ 0 ],
            "bump": [ 0.0 ], "genUV": [ 1.0 ], "alpha": [ 1.0 ],
            "emitThr": [ 0.20 ], "emitAmp": [ 2.0 ],
            "cenX": [ -0.9, sync ], "cenY": [ 0.2 ], "cenZ": [ -1.0 ],
            "rotX": [ 0.0 ], "rotY": [ 0.0 ], "rotZ": [ 0.0, sync ],
            "globalRotX": [ 0.0, sync ], "globalRotY": [ 0.0, sync ], "globalRotZ": [ 0.0, sync ],
            "globalScale": [ 1.0, sync ],
            "rotXDel": [ 0.0, syncFFT ], "rotYDel": [ 172.0 ], "rotZDel": [ 69.0 ],
            "rotSingleX": [ 0.0 ], "rotSingleY": [ 0.0 ], "rotSingleZ": [ 0.0 ],
            "radAmp": [ 0.0 ], "radAmpIn": [ 0.2 ], "radFreq": [ 1.0 ], "radFreqIn": [ 0.0 ],
            "radOfs": [ 0.2 ], "radRotDel": [ 0.0 ], "radDel": [ 0.0 ],
            "delOfs": [ 0.0 ],
            "spx": [ 0.0 ], "spy": [ 0.0 ], "spz": [ 0.0 ],
            "emitPercent": [ 0.0, sync ],
            "emitAngSpd": [ 0.0, sync ],
            "emitVel.x": [ 0.0 ], "emitVel.y": [ 0.0 ], "emitVel.z": [ 0.0 ],
            "emitColThr": [ 0.0 ], "emitGrayness": [ 0.0 ],
            "mirrorX": [ 0.0, sync ], "mirrorXPos": [ 0.0, sync ], "mirrorXClip": [ 0.0, sync ],
            "mirrorY": [ 0.0, sync ], "mirrorYPos": [ 0.0, sync ], "mirrorYClip": [ 0.0, sync ],
            "mirrorZ": [ 0.0, sync ], "mirrorZPos": [ 0.0, sync ], "mirrorZClip": [ 0.0, sync ],
            "circCenX": [ 0.0, sync ], "circCenY": [ 0.0, sync ], "circCenZ": [ 0.0, sync ],
            "circDistX": [ 0.0, sync ], "circDistY": [ 0.0, sync ], "circDistZ": [ 0.0, sync ],
            "circRotX": [ 0.0, sync ], "circRotY": [ 0.0, sync ], "circRotZ": [ 0.0, sync ],

        },

        // preset 3: summoner-breakin
        {
            "num": [ 150000 ],
            "meshIndex": [ 0, sync ],
            "texInd0": [ 0, sync ],
            "texInd1": [ 0 ],
            "blendMode": [ 1 ],
            "depthEnabled": [ 1, sync ],
            "scale": [ 0.50, sync ], "scaleZ": [ 1.0 ],
            "x": [ 0.0, sync ], "y": [ 0.0, sync ], "z": [ 0.0, sync ],
            "bright": [ 0.15, sync ], "ambient": [ 0.01 ],
            "uvScale": [ 1.0 ], "uvScaleMin": [ 0.0 ], "uvScaleMax": [ 0.05 ],
            "uvRandom": [ 1.0 ], "uvOfsXRand": [ 0.15 ], "uvOfsYRand": [ 0.05 ],
            "prevBlur": [ 0.8 ], "prevBlurType": [ 0.0 ],
            "bump": [ 0.50 ], "genUV": [ 1.0 ], "alpha": [ 1.0, sync ],
            "emitThr": [ 0.0 ], "emitAmp": [ 4.0, sync ],
            "cenX": [ 1.1, sync ], "cenY": [ 0.943 ], "cenZ": [ 0.10 ],
            "rotX": [ 0.0 ], "rotY": [ 1.0 ], "rotZ": [ 0.0, sync ],
            "globalRotX": [ 0.0, sync ], "globalRotY": [ 0.0, sync ], "globalRotZ": [ 0.0, sync ],
            "globalScale": [ 1.0, sync ],
            "rotXDel": [ -1.665, syncFFT ], "rotYDel": [ -0.001, sync ], "rotZDel": [ 0.001, sync ],
            "rotSingleX": [ 0.02, syncFFT ], "rotSingleY": [ 1.0 ], "rotSingleZ": [ 0.0 ],
            "radAmp": [ 0.0,sync ], "radAmpIn": [ 0.2 ], "radFreq": [ 0.30 ], "radFreqIn": [ 0.10 ],
            "radOfs": [ -0.02 ], "radRotDel": [ 0.01 ], "radDel": [ 0.01, sync ],
            "delOfs": [ 100000.0 ],
            "spx": [ 0.0 ], "spy": [ 0.0 ], "spz": [ 0.0 ],
            "emitPercent": [ 0.0, sync ],
            "emitAngSpd": [ 0.0, sync ],
            "emitVel.x": [ 0.0 ], "emitVel.y": [ 0.0 ], "emitVel.z": [ 0.0 ],
            "emitColThr": [ 0.0 ], "emitGrayness": [ 0.0 ],
            "mirrorX": [ 0.0, sync ], "mirrorXPos": [ 0.0, sync ], "mirrorXClip": [ 0.0, sync ],
            "mirrorY": [ 0.0, sync ], "mirrorYPos": [ 0.0, sync ], "mirrorYClip": [ 0.0, sync ],
            "mirrorZ": [ 0.0, sync ], "mirrorZPos": [ 0.0, sync ], "mirrorZClip": [ 0.0, sync ],
            "circCenX": [ 0.0, sync ], "circCenY": [ 0.0, sync ], "circCenZ": [ 0.0, sync ],
            "circDistX": [ 0.0, sync ], "circDistY": [ 0.0, sync ], "circDistZ": [ 0.0, sync ],
            "circRotX": [ 0.0, sync ], "circRotY": [ 0.0, sync ], "circRotZ": [ 0.0, sync ],

        },
    ]
}
